/**
 * Clase para las funciones especificadas en la tarea, tales como el audio 
 * y la imagen aparecida al vaciarse el estanque
 * @author Eduardo Garcia, Sebastian Contreras
 */
import java.applet.AudioClip;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import javax.imageio.ImageIO;

public class SpecialFunctions{
/**
 * Constructor de Funciones Especiales
 */
    public SpecialFunctions(){}  
/**
 * Metodo para generar la alerta por el vaciado del estanque
 * @param high Para informar la alerta
 * @param g2d Grafico dibujado
 * @param tank Tanque vaciado
 * @param id Identificador del grafico
 * @param position Posicion de la imagen de alerta
 */    
    public void Speaker(int high, Graphics2D g2d, Tank tank, int id, Point position){
        
        try{
            URL url = getClass().getResource("speaker.gif");
            speaker = ImageIO.read(url);
	}catch (IOException e){}
	try{
            URL sound = getClass().getResource("siren.wav");
            clip = java.applet.Applet.newAudioClip(sound);
	}catch(Exception e){}
        
        if (tank.getLevel()==0&&id==1){
            if((System.currentTimeMillis()/1000)%2==0){
                g2d.drawImage(speaker, null,position.x-130,position.y-high-20);
                if(rep){
                    rep=false;   
                    clip.play(); 
                }
            }
            else rep = true; 			
        }
    }
/**
 * Metodo para dibujar la linea trazada en el grafico
 * @param i Variable para recorrer los arreglos
 * @param id Identificador del grafico
 * @param time_lim Limite de tiempo
 * @param valve Arreglo de valores de la valvula  
 * @param level Arreglo de nivel del estanque
 * @param reference Arreglo del nivel de referencia
 * @param g2d Grafico a ser dibujado
 */
    public void LinkPoints(int i,int id, int time_lim, Point[] valve, Point[] level, Point[] reference, Graphics2D g2d){
        for(i=0;i<time_lim;i++){
            if(valve[i]!=null){
                g2d.setColor(Color.BLUE);
		if(i!=0 && valve[i-1]!=null)
                    g2d.drawLine(valve[i].x,valve[i].y,valve[i-1].x,valve[i-1].y);
                    g2d.setColor(Color.ORANGE);
                    if(i!=0 && level[i-1]!=null)
                        g2d.drawLine(level[i].x,level[i].y,level[i-1].x,level[i-1].y);
                        if(id==2){
                            g2d.setColor(Color.RED);
                            g2d.fillOval(reference[i].x,reference[i].y, 1, 1);
                            if(i!=0 && reference[i-1]!=null)
                                g2d.drawLine(reference[i].x,reference[i].y,reference[i-1].x,reference[i-1].y);	
			}
             }
        }
    }
/**
 * Metodo para limpiar la linea graficada
 * @param level Arreglo de nivel del estanque
 * @param valve Arreglo de valores de la valvula
 * @param reference Arreglo del nivel de referencia
 * @param time_lim Limite de tiempo
 */    
    public void Reset(Point[] level, Point[] valve, Point[] reference, int time_lim) {
        int i;
        for(i=0;i<time_lim;i++){                        
                        valve[i]=null;
                        level[i]=null;
                        reference[i]=null;                                
        }
    }     
    
    private AudioClip clip;
    private BufferedImage speaker;
    private boolean rep=true;
    
}
